class Users::InterestsController < Users::BaseController
  skip_before_action :check_observed_user_exists!
  before_action :require_login, :check_auth

  def create
    identity = params[:identity].to_s.strip

    extension = current_user.user_extension || current_user.build_user_extension
    return render_error('请选择职业') unless %w(teacher student professional).include?(identity)

    ActiveRecord::Base.transaction do
      extension.update_column(:identity, identity)

      # 兴趣
      current_user.user_interests.delete_all
      UserInterest.bulk_insert(:user_id, :repertoire_id) do |worker|
        (Repertoire.pluck(:id) & Array.wrap(params[:interest_ids]).map(&:to_i)).each do |repertoire_id|
          worker.add(user_id: current_user.id, repertoire_id: repertoire_id)
        end
      end
    end

    render_ok
  end
end