class Users::ProjectsController < Users::BaseController
  def index
    projects = Users::ProjectService.new(observed_user, query_params).call

    @count = projects.count
    @projects = paginate(projects.includes(:project_score, owner: { user_extension: :school }), special: true)
  end

  private

  def query_params
    params.permit(:category, :status, :sort_direction)
  end
end