import React, {Component} from "react";
import CoursesListType from '../coursesPublic/CoursesListType';
import {WordsBtn, ActionBtn} from 'educoder';
import TraineetraininginformationModal from './TraineetraininginformationModal';
import ModulationModal from "../coursesPublic/ModulationModal";
import HomeworkModal from "../coursesPublic/HomeworkModal";
import {
	Form,
	Select,
	Input,
	Button,
	Checkbox,
	Upload,
	Icon,
	message,
	Modal,
	Table,
	Pagination,
	Radio,
	Tooltip,
	notification
} from "antd";
import {Link, Switch, Route, Redirect} from 'react-router-dom';
import locale from 'antd/lib/date-picker/locale/zh_CN';
import axios from 'axios';
import Modals from '../../modals/Modals';
import Associationmodel from '../coursesPublic/Associationmodel';
import '../css/members.css'
import '../css/busyWork.css'
import '../poll/pollStyle.css'
import moment from 'moment';
import 'moment/locale/zh-cn';
import {getImageUrl, toPath} from 'educoder';
import ShixunWorkModal from './Shixunworkdetails/ShixunWorkModal';

const Search = Input.Search;
const RadioGroup = Radio.Group;
const CheckboxGroup = Checkbox.Group;
const {Option} = Select;

//GraduationTaskssetting.js
//教师作品页面

//作品列表(教师)
class Listofworks extends Component {
	//unifiedsetting 统一设置
	//allowreplenishment 允许补交
	//completionefficiencyscore 完成效率评分占比
	//level级别
	//proportion 比例
	constructor(props) {
		super(props);
		// console.log(JSON.stringify(props));
		// course_group_info  老师身份显示的分班情况
		//task_status 老师身份显示的提交情况
		//要提交的作品状态checkedValuesine
		//要提交的分班状态checkedValuesineinfo
		//searchtext 输入的姓名和学号
		//order 排序时间
		this.state = {
			props: props,
			data: [],
			page: 1,
			limit: 20,
			loadingstate: true,
			order: undefined,
			search: null,
			task_status: [],
			course_group_info: [],
			teacherdata: undefined,
			checkedValuesine: undefined,
			checkedValuesineinfo: [],
			work_efficiency: false,
			resultint: 0,
			teacherlist: undefined,
			searchtext: "",
			course_groupysls: undefined,
			course_groupyslstwo: undefined,
			visible: false,
			userid: 0,
			course_group: null,
			visibles: false,
			userids: 0,
			viewtrainingdata: {},
			publish_immediately: undefined,
			end_immediately: undefined,
			mystyle: {"display": "block", "color": '#07111B', "text-align": "center"},
			mystyles: {"display": "none", "color": '#07111B', "text-align": "center"},
			mystyle1: {"display": "block"},
			mystyles1: {"display": "none"},
			unlimited: 0,
			unlimitedtwo: 1,
			code_review: false,
			columns: [
				{
					title: '序号',
					dataIndex: 'number',
					key: 'number',
					align: 'center',
					width:'96px',
					render: (text, record) => (
						<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.number}</a>
        </span>
					)
				},
				{
					title: '姓名',
					dataIndex: 'name',
					key: 'name',
					align: 'center',
					Width:'147px',
					render: (text, record) => (
						<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.name}</a>
        </span>
					)
				},
				{
					title: '学号',
					dataIndex: 'stduynumber',
					key: 'stduynumber',
					align: 'center',
					width:'200px',
					render: (text, record) => (
						<span>
             <a style={{
							 "color": '#9A9A9A',
							 "text-align": "center"
						 }}>{record.stduynumber === undefined ? "--" : record.stduynumber === null ? "--" : record.stduynumber === "" ? "--" : record.stduynumber}</a>
        </span>
					),
				},
				{
					title: '分班',
					key: 'classroom',
					dataIndex: 'classroom',
					align: 'center',
					render: (text, record) => (
						<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.classroom}</a>
        </span>
					)
				},
				{
					title: '提交状态',
					dataIndex: 'submitstate',
					key: 'submitstate',
					align: 'center',
					render: (text, record) => (
						<span>
             <a style={record.submitstate === "延时提交" ? {
							 "color": '#DD1717',
							 "text-align": "center"
						 } : record.submitstate === "按时提交" ? {"color": '#29BD8B', "text-align": "center"} : {
							 "color": '#747A7F',
							 "text-align": "center"
						 }}>{record.submitstate}</a>
        </span>
					)

				},
				{
					title: '更新时间',
					dataIndex: 'updatetime',
					key: 'updatetime',
					align: 'center',
					render: (text, record) => (
						<span>
             <a style={{"color": '#9A9A9A', "text-align": "center"}}>{record.updatetime}</a>
        </span>
					),
				},
				{
					title: '完成情况',
					dataIndex: 'completion',
					key: 'completion',
					align: 'center',
					render: (text, record) => (
						<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.completion}</a>
        </span>
					)
				},
				{
					title: '关卡得分',
					dataIndex: 'levelscore',
					key: 'levelscore',
					align: 'center',
					render: (text, record) => (
						<span>
       <a style={parseInt(record.levelscore) <= 60 ? {
				 "color": '#747A7F',
				 "text-align": "center"
			 } : parseInt(record.levelscore) < 90 ? {
				 "color": '#FF6800',
				 "text-align": "center"
			 } : parseInt(record.levelscore) >= 90 ? {"color": '#DD1717', "text-align": "center"} : {
				 "color": '#747A7F',
				 "text-align": "center"
			 }}>{record.levelscore}</a>
        </span>
					)
				},
				{
					title: '效率分',
					dataIndex: 'efficiencyscore',
					key: 'efficiencyscore',
					align: 'center',
					render: (text, record) => (
						<span>
            <a style={parseInt(record.efficiencyscore) <= 60 ? {
							"color": '#747A7F',
							"text-align": "center"
						} : parseInt(record.efficiencyscore) < 90 ? {
							"color": '#FF6800',
							"text-align": "center"
						} : parseInt(record.efficiencyscore) >= 90 ? {
							"color": '#DD1717',
							"text-align": "center"
						} : {"color": '#747A7F', "text-align": "center"}}>{record.efficiencyscore}</a>
        </span>
					)
				},
				{
					title: '最终成绩',
					dataIndex: 'finalscore',
					key: 'finalscore',
					align: 'center',
					render: (text, record) => (
						<span>
           <a style={parseInt(record.finalscore) <= 60 ? {
						 "color": '#747A7F',
						 "text-align": "center"
					 } : parseInt(record.finalscore) < 90 ? {
						 "color": '#FF6800',
						 "text-align": "center"
					 } : parseInt(record.finalscore) >= 90 ? {"color": '#DD1717', "text-align": "center"} : {
						 "color": '#747A7F',
						 "text-align": "center"
					 }}>{record.finalscore}</a>
        </span>
					)
				},
				{
					title: '操作',
					dataIndex: 'operating',
					key: 'operating',
					display: 'block',
					align: 'center',
					width:'93px',
					render: (text, record) => (
						record.submitstate === "未提交" ? "--" :
							<span>
                        <a style={this.props.isNotMember() === true ? this.state.mystyles : this.state.mystyle}
													 onClick={() => this.Viewstudenttraininginformations(record)}>调分</a>
                       <a style={{"text-align": "center"}} className="color-blue"
													onClick={() => this.Viewstudenttraininginformation(record)}>{record.operating}</a>
        </span>
					)
				},
			],


		}

	}

	componentDidMount() {
		var homeworkid = this.props.match.params.homeworkid;
		// console.log(homeworkid)
		// this.Gettitleinformation(homeworkid);
		this.Getalistofworks(homeworkid);
		let query = this.props.location.pathname;
		const type = query.split('/');
		this.setState({
			shixuntypes: type[3]
		})

	}

	isupdatas = () => {
		var homeworkid = this.props.match.params.homeworkid;
		// this.Gettitleinformation(homeworkid);
		this.Getalistofworks(homeworkid);
	}

	// 获取作品列表
	Getalistofworks = (homeworkid) => {
		// console.log("获取作品列表");7009
		let urll = `/homework_commons/${homeworkid}/works_list.json`;
		// console.log(homeworkid);

		// search:搜索关键字
		// order:排序方式：更新时间：update_time，最终成绩：work_score，学号：student_id
		// b_order:desc：倒序 ， asc：顺序
		// work_status:0:未提交， 1:按时提交， 2:延时提交，“”不限
		// course_group:分班情况 [232, 231]， []:不限（空数组）
		var data = {
			search: "",
			order: "",
			b_order: "",
			work_status: "",
			course_group: "",
		}
		axios.post(urll, data).then((result) => {
			if (result !== undefined) {
				// console.log(url)
				// console.log("作品列表6789077")
				// console.log(JSON.stringify(result))
				this.setState({
					teacherdata: result.data,
					task_status: result.data.task_status,
					course_group_info: result.data.course_group_info,
					loadingstate: false,
					jobsettingsdata: result,
					publish_immediately: result.data.publish_immediately,
					work_efficiency: result.data.work_efficiency,
					end_immediately: result.data.end_immediately,
					code_review: result.data.code_review
				})
				this.seacthdata();
			}
		}).catch((error) => {
			console.log(error)
			this.setState({
				loadingstate: false,
			})
		})
	}

	//开始排序操作
	Startsorting = (ordervlue, checkedValuesine, checkedValuesineinfo, searchtext, page, limit) => {
		//要提交的作品状态checkedValuesine
		//要提交的分班状态checkedValuesineinfo
		//searchtext 输入的姓名和学号
		//order 排序时间
		//debug=t 是老师的意思
		// console.log(ordervlue)7009
		var homeworkid = this.props.match.params.homeworkid;
		let urll = `/homework_commons/${homeworkid}/works_list.json?`;
		var order = "asc";
		if (ordervlue === "updated_at") {
			order = "desc";
		}
		var checkedValuesines = checkedValuesine;
		var checkedValuesineinfos = checkedValuesineinfo;
		var searchtexts = searchtext
		var data = {
			search: searchtexts,
			order: ordervlue,
			b_order: order,
			work_status: checkedValuesines,
			course_group: checkedValuesineinfos,
			page: page,
			limit: limit,
		}
		// console.log("Startsorting");
		// console.log(data);
		axios.post(urll, data).then((result) => {
			// if (result.status === 200) {/]
			// console.log(url)
			// console.log("作品列表______________________")
			// console.log(JSON.stringify(result))
			if (result !== undefined) {
				this.setState({
					teacherdata: result.data,
					task_status: result.data.task_status,
					course_group_info: result.data.course_group_info,
					loadingstate: false,
				})

				this.seacthdata();
			}

			// }
		}).catch((error) => {
			console.log(error)
			this.setState({
				loadingstate: false
			})
		})


	}

	TablePagination = (e) => {
		// console.log(e.current);
		var teacherlist = {  //分页
			total: this.state.teacherdata.student_works.length, //数据总数量
			pageSize: 20,  //一页显示几条
			current: e.current,
		}
		this.setState({
			page: e.current,
			teacherlist: teacherlist
		})

	}


	// 设置数据
	seacthdata = () => {
		let {page, limit} = this.state;
		let datalist = [];
		let columns = this.state.columns;
		if (this.state.teacherdata !== undefined) {
			for (var i = 0; i < this.state.teacherdata.student_works.length; i++) {
				var timedata = moment(this.state.teacherdata.student_works[i].update_time).format('YYYY-MM-DD HH:mm');
				datalist.push({
					myid: this.state.teacherdata.student_works[i].id,
					number: (parseInt(page) - 1) * parseInt(limit) + (i + 1),
					name: this.state.teacherdata.student_works[i].user_name,
					stduynumber: this.state.teacherdata.student_works[i].student_id,
					classroom: this.state.teacherdata.student_works[i].group_name,
					submitstate: this.state.teacherdata.student_works[i].work_status === 0 ? "未提交" : this.state.teacherdata.student_works[i].work_status === 1 ? "按时提交" : this.state.teacherdata.student_works[i].work_status === 2 ? "延时提交" : "未提交",
					// updatetime:this.state.teacherdata.student_works[i].update_time,
					// updatetime:"",
					updatetime: timedata === "Invalid date" ? "--" : timedata,
					completion: this.state.teacherdata.student_works[i].complete_count === 4 ? "4/4" : this.state.teacherdata.student_works[i].complete_count === 3 ? "3/4" : this.state.teacherdata.student_works[i].complete_count === 2 ? "2/4" : this.state.teacherdata.student_works[i].complete_count === 1 ? "1/4" : this.state.teacherdata.student_works[i].complete_count === 0 ? "0/0" :this.state.teacherdata.student_works[i].complete_count == null ? "0/0" :this.state.teacherdata.student_works[i].complete_count == undefined ? "0/0": 0,
					levelscore: this.state.teacherdata.student_works[i].final_score,
					efficiencyscore: this.state.teacherdata.student_works[i].eff_score,
					finalscore: this.state.teacherdata.student_works[i].work_score,
					operating: "查看",
				})

			}

			var teacherlist = {  //分页
				total: this.state.teacherdata.student_works.length, //数据总数量
				pageSize: 20,  //一页显示几条
				current: this.state.page,
			}
			if (this.state.work_efficiency === false) {
				columns = [
					{
						title: '序号',
						dataIndex: 'number',
						key: 'number',
						align: 'center',
						width:'96px',
						render: (text, record) => (
							<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.number}</a>
        </span>
						)
					},
					{
						title: '姓名',
						dataIndex: 'name',
						key: 'name',
						align: 'center',
						width:'147px',
						render: (text, record) => (
							<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.name}</a>
        </span>
						)
					},
					{
						title: '学号',
						dataIndex: 'stduynumber',
						key: 'stduynumber',
						align: 'center',
						width:'200px',
						render: (text, record) => (
							<span>
             <a style={{
							 "color": '#9A9A9A',
							 "text-align": "center"
						 }}>{record.stduynumber === undefined ? "--" : record.stduynumber === null ? "--" : record.stduynumber === "" ? "--" : record.stduynumber}</a>
        </span>
						),
					},
					{
						title: '分班',
						key: 'classroom',
						dataIndex: 'classroom',
						align: 'center',
						render: (text, record) => (
							<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.classroom}</a>
        </span>
						)
					},
					{
						title: '提交状态',
						dataIndex: 'submitstate',
						key: 'submitstate',
						align: 'center',
						render: (text, record) => (
							<span>
             <a style={record.submitstate === "延时提交" ? {
							 "color": '#DD1717',
							 "text-align": "center"
						 } : record.submitstate === "按时提交" ? {"color": '#29BD8B', "text-align": "center"} : {
							 "color": '#747A7F',
							 "text-align": "center"
						 }}>{record.submitstate}</a>
        </span>
						)

					},
					{
						title: '更新时间',
						dataIndex: 'updatetime',
						key: 'updatetime',
						align: 'center',
						render: (text, record) => (
							<span>
             <a style={{"color": '#9A9A9A', "text-align": "center"}}>{record.updatetime}</a>
        </span>
						),
					},
					{
						title: '完成情况',
						dataIndex: 'completion',
						key: 'completion',
						align: 'center',

						render: (text, record) => (
							<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.completion}</a>
        </span>
						)
					},
					{
						title: '最终成绩',
						dataIndex: 'finalscore',
						key: 'finalscore',
						align: 'center',
						render: (text, record) => (
							<span>
             <a style={parseInt(record.finalscore) <= 60 ? {
							 "color": '#747A7F',
							 "text-align": "center"
						 } : parseInt(record.finalscore) < 90 ? {
							 "color": '#FF6800',
							 "text-align": "center"
						 } : parseInt(record.finalscore) >= 90 ? {"color": '#DD1717', "text-align": "center"} : {
							 "color": '#747A7F',
							 "text-align": "center"
						 }}>{record.finalscore}</a>

        </span>
						)
					},
					{
						title: '操作',
						dataIndex: 'operating',
						key: 'operating',
						display: 'block',
						align: 'center',
						width:'96px',
						render: (text, record) => (
							record.submitstate === "未提交" ? "--" :
								<span>
                        <a style={this.props.isNotMember() === true ? this.state.mystyles : this.state.mystyle}
													 onClick={() => this.Viewstudenttraininginformations(record)}>调分</a>
                        <a style={{"display": "block", "text-align": "center"}} className="color-blue"
													 onClick={() => this.Viewstudenttraininginformation(record)}>{record.operating}</a>
        </span>
						)
					},
				]
			}

		} else {
			var teacherlist = undefined;
		}
		this.setState({
			data: datalist,
			teacherlist: teacherlist,
			columns: columns,
			loadingstate: false,
		})
	}
	//作品状态
	funtaskstatus = (checkedValues, data) => {

		if (JSON.stringify(checkedValues) === "[]") {
			// console.log(checkedValues);
			this.setState({
				unlimited: 0,
				course_groupyslstwo: undefined,
				loadingstate: true,

			})
			this.Startsorting(this.state.order, checkedValues, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
		} else if (checkedValues.length === data.length) {
			this.setState({
				unlimited: 0,
				course_groupyslstwo: undefined,
				loadingstate: true,
			})
			this.Startsorting(this.state.order, checkedValues, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
		} else {
			// console.log(checkedValues);
			this.setState({
				course_groupyslstwo: checkedValues,
				unlimited: 1,
				loadingstate: true
			})
			this.Startsorting(this.state.order, checkedValues, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);


		}

	}
	//作品状态2
	funtaskstatustwo = (checkedValues, data) => {
		// console.log("funtaskstatustwo");
		// console.log(checkedValues);
		if (JSON.stringify(checkedValues) === "[]") {
			// console.log(checkedValues);
			this.setState({
				unlimitedtwo: 1,
				course_groupysls: undefined,
				loadingstate: true,

			})
			this.Startsorting(this.state.order, this.state.course_groupyslstwo, checkedValues, this.state.searchtext, this.state.page, this.state.limit);
		} else if (checkedValues.length === data.length) {
			this.setState({
				unlimitedtwo: 1,
				course_groupysls: undefined,
				loadingstate: true,
			})
			this.Startsorting(this.state.order, this.state.checcourse_groupyslstwokedValuesine, checkedValues, this.state.searchtext, this.state.page, this.state.limit);
		} else {
			this.setState({
				checkedValuesineinfo: checkedValues,
				course_groupysls: checkedValues,
				unlimitedtwo: 0,
				loadingstate: true,
			})
			this.Startsorting(this.state.order, this.state.course_groupyslstwo, checkedValues, this.state.searchtext, this.state.page, this.state.limit);


		}

	}
	//搜索学生 文字输入
	inputSearchValues = (e) => {
		// console.log(e.target.value)
		if (e.target.value === "") {
			this.setState({
				searchtext: undefined
			})
		} else {
			this.setState({
				searchtext: e.target.value
			})
		}

	}

	//搜索学生按钮输入
	searchValues = (value) => {
		//点击直接搜索
		//    if(value === ""){
		//        message.error("请输入姓名或学号搜索");
		//        return
		//    }
		this.setState({
			loadingstate: true
		})
		this.Startsorting(this.state.order, this.state.course_groupyslstwo, this.state.checkedValuesineinfo, value, this.state.page, this.state.limit);
		// console.log(value)


	}

	// 输入关键字后按回车，自动提交
	onSearchKeywordKeyUp = (e) => {
		if (e.keyCode === 13) {
			// this.onSearch();
			// console.log("使用了回车键");
			this.setState({
				loadingstate: true
			})
			this.Startsorting(this.state.order, this.state.course_groupyslstwo, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
		}
	}
	//排序
	funorder = (e) => {
		if (e === "updated_at") {
			// 时间
			// 时间排序是从小到大
			this.setState({
				order: "updated_at",
				loadingstate: true,
			})
			this.Startsorting("updated_at", this.state.course_groupyslstwo, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
		}

		if (e === "work_score") {
			// 成绩
			//成绩排序是从大到小
			this.setState({
				order: "work_score",
				loadingstate: true,
			})
			this.Startsorting("work_score", this.state.course_groupyslstwo, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
		}

		if (e === "student_id") {
			//学号
			//学号排序是从大到小
			this.setState({
				order: "student_id",
				loadingstate: true,
			})
			this.Startsorting("student_id", this.state.course_groupyslstwo, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
		}
	}


	// 调分

	// 查看学员实训信息
	Viewstudenttraininginformation = (e) => {
		// console.log("Viewstudenttraininginformation");
		// console.log(e);
		this.setState({
			userids: e.myid,
		})
		this.viewtraining(e.myid);
	}
	// 关闭调分
	cancelModulationModels = () => {
		this.setState({visibles: false})
	}
	// 关闭查看
	cancelModulationModel = () => {
		this.setState({visible: false})
	}
	// 调分
	Viewstudenttraininginformations = (e) => {
		// console.log("Viewstudenttraininginformations2");
		// console.log(e.myid);
		this.setState({
			visible: true,
			userid: e.myid,
			// Tune：
		})
	}
	//确定
	saveModulationModal = (value, num) => {
		var userid = this.state.userid;
		const url = `/student_works/${userid}/adjust_score.json`;
		// console.log(url);
		axios.post(url, {
				score: num,
				comment: value
			})
			.then((response) => {
				if (response.data.status == '0') {
					this.setState({visible: false});
					this.props.showNotification(`调分成功`);

					this.Startsorting(this.state.order, this.state.course_groupyslstwo, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);
				}
			})
			.catch(function (error) {
				console.log(error);
			});
	}

	viewtraining = (userids) => {
		// console.log(JSON.stringify(this.props.user))
		var url = `/student_works/${userids}/shixun_work.json`;
		axios.get(url).then((result) => {
			if (result.status === 200) {
				// console.log("TraineetraininginformationModal.js")
				// console.log(JSON.stringify(result))
				let datalist = [];
				var game_list = result.data.game_list

				for (var i = 0; i < game_list.length; i++) {

					datalist.push({
						number: "第" + game_list[i].position + "关",
						name: moment(game_list[i].end_time).format('YYYY-MM-DD HH:mm'),
						stduynumber: game_list[i].cost_time,
						classroom: game_list[i].score,
						complete_status: game_list[i].complete_status,
					})

				}
				// console.log("viewtraining");
				// console.log(datalist);
				// console.log(JSON.stringify(datalist));
				this.setState({
					viewtrainingdata: result.data,
					visibles: true,
					game_list: datalist
				})
			}
		}).catch((error) => {

		})
	}


	//立即发布
	homeworkstart = () => {
		let homeworkid = this.props.match.params.homeworkid;
		let url = "/homework_commons/" + homeworkid + "/publish_groups.json";


		axios.get(url).then((response) => {

			if (response.status === 200) {
				let starttime = this.props.getNowFormatDates(1);
				let endtime = this.props.getNowFormatDates(2);
				this.setState({
					modalname: "立即发布",
					modaltype: response.data.course_groups === null || response.data.course_groups.length === 0 ? 2 : 1,
					svisible: true,
					Topval: "本操作只对“未发布”的对象生效",
					Botvalleft: "暂不发布",
					Botval: "则通过后续手动设置，定时发布",
					starttime: "发布时间：" + starttime,
					endtime: "截止时间：" + endtime,
					starttimes:starttime,
					typs:"start",
					Cancelname: "暂不发布",
					Savesname: "立即发布",
					Cancel: this.homeworkhide,
					Saves: this.homeworkstartend,
					course_groups: response.data.course_groups,
				})
			}
		}).catch((error) => {
			console.log(error)
		});

	}
	//立即截止
	homeworkends = () => {
		let homeworkid = this.props.match.params.homeworkid;
		let url = "/homework_commons/" + homeworkid + "/end_groups.json";

		axios.get(url).then((response) => {

			if (response.status === 200) {
				this.setState({})
				this.setState({
					modalname: "立即截止",
					modaltype: response.data.course_groups === null || response.data.course_groups.length === 0 ? 2 : 1,
					svisible: true,
					Topval: "本操作只对“提交中”的对象生效",
					Botvalleft: "暂不截止",
					Botval: "则将根据已设置的截止时间，定时截止",
					Cancelname: "暂不截止",
					Savesname: "立即截止",
					Cancel: this.homeworkhide,
					Saves: this.coursetaskend,
					starttime: undefined,
					endtime: undefined,
					course_groups: response.data.course_groups,
					typs:"end",
				})
			}
		}).catch((error) => {
			console.log(error)
		});


	}
// 立即发布
	homeworkstartend = (ds,endtime) => {
		var homeworkid = this.props.match.params.homeworkid;
		let {course_groupslist} = this.state;

		let coursesId = this.props.match.params.coursesId;
		let url = "/courses/" + coursesId + "/homework_commons/publish_homework.json";
		axios.post(url, {
			homework_ids: [homeworkid],
			group_ids: course_groupslist,
			end_time:endtime,
		}).then((result) => {
			if (result.status === 200) {
				if (result.data.status === 0) {
					notification.open({
						message: "提示",
						description: result.data.message
					});
					this.homeworkhide()
				}

			}
		}).catch((error) => {
			console.log(error);
		})
	}
	notlimiteds = () => {
		this.setState({
			checkedValuesine: undefined,
			course_groupyslstwo: undefined,
			unlimited: 0,
			loadingstate: true,
		})
		this.Startsorting(this.state.order, null, this.state.checkedValuesineinfo, this.state.searchtext, this.state.page, this.state.limit);

	}
	notlimitedst = () => {
		// console.log(this.state.course_group_info);
		this.setState({
			unlimitedtwo: 1,
			checkedValuesineinfo: undefined,
			course_groupysls: undefined,
			loadingstate: true,
		})
		this.Startsorting(this.state.order, this.state.course_groupyslstwo, undefined, this.state.searchtext, this.state.page, this.state.limit);
	}
	//立即截止确定按钮
	coursetaskend = () => {
		var homeworkid = this.props.match.params.homeworkid;
		let {course_groupslist} = this.state;


		const cid = this.props.match.params.coursesId;
		let url = "/courses/" + cid + "/homework_commons/end_homework.json";
		axios.post(url, {
				group_ids: course_groupslist,
				homework_ids: [homeworkid],
			})
			.then((response) => {
				if (response.data.status == 0) {
					notification.open({
						message: "提示",
						description: response.data.message
					});
					this.homeworkhide()
				}
			})
			.catch(function (error) {
				console.log(error);
			});
	}

	getcourse_groupslist = (id) => {
		this.setState({
			course_groupslist: id
		})

	}

	homeworkhide = () => {
		this.isupdatas()
		this.setState({
			modalname: undefined,
			modaltype: undefined,
			svisible: false,
			Topval: undefined,
			Topvalright: undefined,
			Botvalleft: undefined,
			Botval: undefined,
			starttime: undefined,
			endtime: undefined,
			Cancelname: undefined,
			Savesname: undefined,
			Cancel: undefined,
			Saves: undefined,
			StudentList_value: undefined,
			addname: undefined,
			addnametype: false,
			addnametab: undefined,
			course_groupyslstwo: undefined,
			typs:undefined,
			starttimes:undefined,
		})
	}


	workshowmodel = () => {
		this.setState({
			showmodel: true
		})
	}

	hideshowmodel = () => {
		this.setState({
			showmodel: false
		})
	}

	paginationonChanges = (pageNumber) => {
		this.setState({
			page: pageNumber,
			loadingstate: true,
		})
		this.Startsorting(this.state.order, this.state.course_groupyslstwo, this.state.checkedValuesineinfo, this.state.searchtext, pageNumber, this.state.limit);

	}

	render() {
		// console.log("Listofworks.js000")

		let {columns, page, limit, course_groupysls, course_groupyslstwo, unlimited, unlimitedtwo, loadingstate, viewtrainingdata, game_list, data, course_group_info, order, teacherdata, task_status, checkedValuesine, searchtext, teacherlist, visible, visibles, jobsettingsdata} = this.state;
		//
		// console.log(teacherdata&&teacherdata.shixun_identifier)
		// console.log(course_group_info)
		// console.log(JSON.stringify(this.props));
		return (
			<div className="newMain clearfix ">
				{visible === true ? <ModulationModal
					visible={visible}
					Cancel={this.cancelModulationModel}
					Saves={(value, num) => this.saveModulationModal(value, num)}
				/> : ""}

				{this.state.showmodel === true ? <ShixunWorkModal
					{...this.props}
					visible={this.state.showmodel}
					modalname={"代码查重"}
					data={[]}
					issCancel={() => this.hideshowmodel()}
					updatas={() => this.isupdatas()}
				/> : ""}


				{visibles === true ?
					<div>
						<style>
							{
								`
              body {
         overflow: hidden !important;
       }
              `
							}
						</style>
						<TraineetraininginformationModal
							{...this.props} {...this.state}
							homeworkid={this.props.match.params.homeworkid}
							coursesId={this.props.match.params.coursesId}
							workid={teacherdata.id}
							isAdmins={this.props.isAdmin()}
							userids={this.state.userids}
							viewtrainingdata={viewtrainingdata}
							game_list={game_list}
							visible={visibles}
							Cancel={() => this.cancelModulationModels()}
						/>

					</div>
					: ""
				}

				{/*立即发布*/}
				<HomeworkModal
					modaltype={this.state.modaltype}
					modalname={this.state.modalname}
					visible={this.state.svisible}
					Topval={this.state.Topval}
					Topvalright={this.state.Topvalright}
					Botvalleft={this.state.Botvalleft}
					Botval={this.state.Botval}
					starttime={this.state.starttime}
					endtime={this.state.endtime}
					Cancelname={this.state.Cancelname}
					Savesname={this.state.Savesname}
					Cancel={this.state.Cancel}
					Saves={this.state.Saves}
					course_groups={this.state.course_groups}
					getcourse_groupslist={(id) => this.getcourse_groupslist(id)}
					starttimes={this.state.starttimes}
					typs={this.state.typs}
				/>
				<div className={"educontent mb20"}>
					<div className="educontent mb30">
						<p className="clearfix mb20 mt10">
							<ActionBtn className=" btn colorgrey fl hovercolorblue "
												 to={`/courses/${this.props.match.params.coursesId}/students`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.course_name}</ActionBtn>
							<span className="color-grey-9 fl ml3 mr3">&gt;</span>
							<ActionBtn
								className=" btn colorgrey fl hovercolorblue "
								to={`/courses/${this.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_id}`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_name}</ActionBtn>
							<span className="color-grey-9 fl ml3 mr3">&gt;</span>
							<WordsBtn className="fl">作业详情</WordsBtn>
						</p>
					</div>
					<div className="educontent mb30">
						<p className=" fl color-black  summaryname">
							{teacherdata === undefined ? "" : teacherdata.homework_name}
						</p>
						<CoursesListType
							typelist={teacherdata === undefined ? [""] : teacherdata.homework_status}
						/>
						<a className="color-grey-9 fr font-16  summaryname  ml20 mr20"
							 href={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_id}`}>返回</a>
						<a className="color-grey-9 fr font-16 mr20"
							 href={`/shixuns/${teacherdata === undefined ? "" : teacherdata.shixun_identifier}/challenges`}
							 target={"_blank"}>实训详情</a>


					</div>

					<div className="edu-back-white">
						<div className="stud-class-set bor-bottom-greyE ">
							<div className=" clearfix edu-back-white poll_list">
								<Link className="active"
											to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/list`}>作品列表</Link>
								<Link
									to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/questions`}>作业问答</Link>
								{this.props.isAdmin() ?
									this.state.code_review === false ? "" : <Link
										// to={`/courses/${this.state.props.match.params.coursesId}/${this.state.props.match.params.homeworkid}/student_work`}
										to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/student_work`}>
										代码查重</Link> : ""}
								<Link
									to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/settings`}
								>设置</Link>
								{this.props.isAdmin() ? <a
									className="fr color-blue font-16"
									href={`/api/homework_commons/${this.props.match.params.coursesId}/works_list.xls`}
								>导出</a> : ""}
								{this.props.isAdmin() ?
									teacherdata && teacherdata.end_immediately === true ?
										<a className="fr color-blue font-16" onClick={this.homeworkends}>立即截止</a> : ""
									: ""}
								{this.props.isAdmin() ?
									teacherdata && teacherdata.publish_immediately === true ?
										<a className="fr color-blue font-16" onClick={this.homeworkstart}>立即发布</a> : ""
									: ""}
								{/*<a className="fr color-blue font-16" href={`/courses/${this.state.props.match.params.coursesId}/${this.state.props.match.params.homeworkid}/commitsummary`}>提交总结</a>*/}

								{this.props.isAdmin() ?
									this.state.code_review === true ?
										""
										: <a className="fr color-blue font-16" onClick={this.workshowmodel}>代码查重</a> : ""}
							</div>
						</div>


						{/*作品状态GraduationTaskssettinglist*/}
						<ul className="clearfix" style={{padding: '20px 15px 10px 20px'}}>
							<li className="clearfix ">

								<span className="fl  mr10 color-grey-8 ">作品状态：</span>
								<span className="fl "><a id="graduation_comment_no_limit"
																				 className={unlimited === 0 ? "pl10 pr10 mr20 check_on" : "pl10 pr10 mr20 "}
																				 onClick={() => this.notlimiteds()}>不限</a></span>
								<CheckboxGroup value={course_groupyslstwo}
															 onChange={(e) => this.funtaskstatus(e, task_status && task_status)}
															 style={{paddingTop: '4px'}}>

									{task_status === undefined ? "" : task_status.map((item, key) => {
										return (
											<span key={key}>
                                <Checkbox value={item.id}
																					className="fl ">{item.name}
																	<span>({item.count})</span>
                                </Checkbox>

                            </span>
										)
									})}
								</CheckboxGroup>
								{/*请输入姓名或学号搜索*/}

								<div className="fr mr5 search-new" style={{marginBottom: '1px'}}>
									<Search
										placeholder="请输入姓名或学号搜索"
										id="subject_search_input"
										autoComplete="off"
										value={searchtext}
										onKeyUp={(e) => this.onSearchKeywordKeyUp(e)}
										onInput={this.inputSearchValues}
										onSearch={this.searchValues}
									></Search>
								</div>
							</li>


							{/*分班情况*/}

							<li className="clearfix  mt10 ">
								{JSON.stringify(course_group_info) === "[]" ? "" : course_group_info === undefined ? "" : course_group_info.length < 2 ? "" :
									<div>
										<span className="fl mr10 color-grey-8">分班情况：</span>
										<span className="fl "><a id="graduation_comment_no_limit"
																						 className={unlimitedtwo === 0 ? "pl10 pr10 mr20 " : "pl10 pr10 mr20 check_on"}
																						 onClick={() => this.notlimitedst()}>不限</a></span>
										<CheckboxGroup value={course_groupysls}
																	 onChange={(e) => this.funtaskstatustwo(e, course_group_info && course_group_info)}
																	 style={{paddingTop: '4px'}}>
											{course_group_info === undefined ? "" :
												course_group_info.map((item, key) => {
													return (
														<span key={key}>
                                <Checkbox value={item.course_group_id}
																					className="fl ">{item.group_group_name}
																	<span>({item.count})</span>
                                            </Checkbox>
                            </span>
													)
												})
											}
										</CheckboxGroup>
									</div>}
							</li>

						</ul>


						<div id="graduation_work_list" style={{padding: '0px 20px 10px 20px'}}>

							<div className="clearfix">
                                <span className="fl color-grey-6 font-12"><span
																	className="color-orange-tip">{teacherdata === undefined ? "" : teacherdata.student_works.length}</span>个检索结果（{teacherdata === undefined ? "" : teacherdata.all_member_count}学生） </span>
								<div className="fr color-grey-6 edu-menu-panel">
									<ul>
										<li className="edu-position edu-position-hidebox">
											<a className="font-12 color-grey-6">
												{order === "updated_at" ? "时间" : order === "work_score" ? "成绩" : order === "student_id" ? "学号" : ""}排序</a>
											<i className="iconfont icon-xiajiantou ml5 font-12 color-grey-6"></i>
											<ul className="edu-position-hide undis mt10">
												<li> <a  onClick={(e) => this.funorder("updated_at")} data-remote="true" className="color-grey-6 font-12" style={{"text-align": "center "}}>更新时间</a></li>
												<li> <a  onClick={(e) => this.funorder("work_score")} data-remote="true" className="color-grey-6 font-12" style={{"text-align": "center "}}>最终成绩</a></li>
												<li> <a  onClick={(e) => this.funorder("student_id")} data-remote="true" className="color-grey-6 font-12" style={{"text-align": "center "}}>学生学号</a></li>
											</ul>
										</li>
									</ul>
								</div>


							</div>

						</div>
						{
							JSON.stringify(data) === "[]" ?

								<div id="forum_list" className="forum_table">
									<div className="mh650 edu-back-white">
										<div className="edu-tab-con-box clearfix edu-txt-center">
											<img className="edu-nodata-img mb20" src={getImageUrl("images/educoder/nodata.png")}/>
											<p className="edu-nodata-p mb30">没有数据可以显示！</p>
										</div>
									</div>

								</div>
								:

								<div className={"justify break_full_word new_li edu-back-white"} style={{minHeight: "480px"}}>
									<style>{`
              	          .ant-spin-nested-loading > div > .ant-spin .ant-spin-dot {
																			top: 72%;}
						                }
						                .edu-table thead th,.edu-table tbody tr:last-child td{
															border-bottom: none!important;
															height: 85px;
														}
														.ant-table-tbody > tr > td {
														height: 85px;
															}
						              `}</style>
									<div className="edu-table edu-back-white ">
										{data === undefined ? "" : <Table
											dataSource={data}
											columns={columns}
											pagination={false}
											loading={loadingstate}
											onChange={this.TablePagination}
										/>}
									</div>
								</div>
						}


					</div>
					{
						teacherdata && teacherdata.work_count && teacherdata.work_count > limit ?
							<div className="edu-txt-center mt30 mb20">
								<Pagination showQuickJumper current={page}
														onChange={this.paginationonChanges} pageSize={limit}
														total={teacherdata.work_count}></Pagination>
							</div>
							: ""
					}
				</div>

			</div>

		)
	}
}

export default Listofworks;