import React, {Component} from 'react';

import {Input, Select, Radio, Checkbox, Popconfirm, message, Modal} from 'antd';

import {BrowserRouter as Router, Route, Link, Switch} from "react-router-dom";

// import "antd/dist/antd.css";

import axios from 'axios';

import './css/TPMchallengesnew.css';

import { getImageUrl, toPath } from 'educoder';

import {getUrl} from 'educoder';

let origin = getUrl();

let path = getUrl("/editormd/lib/")

const $ = window.$;

let timeout;

let currentValue;

const Option = Select.Option;

const RadioGroup = Radio.Group;

// 恢复数据
function md_rec_data(k,mdu,id, editor){
    if(window.sessionStorage.getItem(k+mdu) !== null){
        editor.setValue(window.sessionStorage.getItem(k+mdu));
        md_clear_data(k,mdu,id);
    }
}

// 保存数据
function md_add_data(k,mdu,d){
    window.sessionStorage.setItem(k+mdu,d);
}

// 清空保存的数据
function md_clear_data(k,mdu,id){
    window.sessionStorage.removeItem(k+mdu);
    var id1 = "#e_tip_"+id;
    var id2 = "#e_tips_"+id;
    if(k == 'content'){
        $(id2).html("");
    }else{
        $(id1).html("");
    }
}

function md_elocalStorage(editor,mdu,id){
    if (window.sessionStorage){
        var oc = window.sessionStorage.getItem('content'+mdu);
        if(oc !== null ){

            $("#e_tips_"+id).data('editor', editor);
            var h = '您上次有已保存的数据，是否<a style="cursor: pointer;" class="link-color-blue" onclick="md_rec_data(\'content\',\''+ mdu + '\',\'' + id + '\')">恢复</a> ? / <a style="cursor: pointer;" class="link-color-blue" onclick="md_clear_data(\'content\',\''+ mdu + '\',\'' + id + '\')">不恢复</a>';
            $("#e_tips_"+id).html(h);
        }
        setInterval(function() {
            var d = new Date();
            var h = d.getHours();
            var m = d.getMinutes();
            var s = d.getSeconds();
            h = h < 10 ? '0' + h : h;
            m = m < 10 ? '0' + m : m;
            s = s < 10 ? '0' + s : s;
            if(editor.getValue().trim() != ""){
                md_add_data("content",mdu,editor.getValue());
                var id1 = "#e_tip_"+id;
                var id2 = "#e_tips_"+id;

                $(id1).html(" 数据已于 " + h + ':' + m + ':' + s +" 保存   ");
                $(id2).html("");
            }
        },10000);

    }else{
        $("#e_tip_"+id).after('您的浏览器不支持localStorage.无法开启自动保存草稿服务,请升级浏览器！');
    }
}


function create_editorMD(id, width, high, placeholder, imageUrl, callback) {
    var editorName = window.editormd(id, {
        width: width,
        height: high,
        path: path,   // "/editormd/lib/"

        syncScrolling: "single",
        tex: true,
        tocm: true,
        emoji: true,
        taskList: true,
        codeFold: true,
        searchReplace: true,
        htmlDecode: "style,script,iframe",
        sequenceDiagram: true,
        autoFocus: false,
        toolbarIcons: function () {
            // Or return editormd.toolbarModes[name]; // full, simple, mini
            // Using "||" set icons align right.
            return ["bold", "italic", "|", "list-ul", "list-ol", "|", "code", "code-block", "|", "testIcon", "testIcon1", '|', "image", "table", '|', "watch", "clear"]
        },
        toolbarCustomIcons: {
            testIcon: "<a type=\"inline\" class=\"latex\" ><div class='zbg'></div></a>",
            testIcon1: "<a type=\"latex\" class=\"latex\" ><div class='zbg_latex'></div></a>"
        },
        //这个配置在simple.html中并没有，但是为了能够提交表单，使用这个配置可以让构造出来的HTML代码直接在第二个隐藏的textarea域中，方便post提交表单。
        saveHTMLToTextarea: true,
        // 用于增加自定义工具栏的功能，可以直接插入HTML标签，不使用默认的元素创建图标
        dialogMaskOpacity: 0.6,
        placeholder: placeholder,
        imageUpload: true,
        imageFormats: ["jpg", "jpeg", "gif", "png", "bmp", "webp", "JPG", "JPEG", "GIF", "PNG", "BMP", "WEBP"],
        imageUploadURL: imageUrl,//url
        onload: function () {
            // this.previewing();
            $("#" + id + " [type=\"latex\"]").bind("click", function () {
                editorName.cm.replaceSelection("```latex");
                editorName.cm.replaceSelection("\n");
                editorName.cm.replaceSelection("\n");
                editorName.cm.replaceSelection("```");
                var __Cursor = editorName.cm.getDoc().getCursor();
                editorName.cm.setCursor(__Cursor.line - 1, 0);
            });

            $("#" + id + " [type=\"inline\"]").bind("click", function () {
                editorName.cm.replaceSelection("$$$$");
                var __Cursor = editorName.cm.getDoc().getCursor();
                editorName.cm.setCursor(__Cursor.line, __Cursor.ch - 2);
                editorName.cm.focus();
            });
            $("[type=\"inline\"]").attr("title", "行内公式");
            $("[type=\"latex\"]").attr("title", "多行公式");

            md_elocalStorage(editorName, `exercise__${id}`, "Memochallengesnew");

            callback && callback()
        }
    });
    return editorName;
}


export default class TPMchallengesnew extends Component {
    constructor(props) {
        super(props)
        this.state = {
            choice_url: undefined,
            practice_url: undefined,
            go_back_url: undefined,
            task_pass_default: undefined,
            submit_url: undefined,
            shixunCreatePracticeGroup: 1,
            optionsums:[100,200],
            activetype:0,
            setopen: false,
            shixunCreatePractice: undefined,
            onshixunsmarkvalue: 100,
            shixunsskillvalue: undefined,
            shixunsskillvaluelist: [],
            tab2url: "",
            tab3url: "",
            prev_challenge:undefined,
            next_challenge:undefined,
            power: false,
            shixunCreatePracticetype: false,
            shixunsskillvaluelisttype: false,
            marktype:false,
            editPracticesendtype:false,
            CreatePracticesendtype:false
        }
    }


    exerciseMD(initValue, id) {

        this.contentChanged = false;
        const placeholder = "";
        // amp;
        // 编辑时要传memoId
        const imageUrl = `/api/attachments.json`;
        // 创建editorMd

        const exercise_editormd = create_editorMD(id, '100%', 400, placeholder, imageUrl, () => {
            setTimeout(() => {
                exercise_editormd.resize()
                exercise_editormd.cm && exercise_editormd.cm.refresh()
            }, 500)

            if (initValue != undefined) {
                exercise_editormd.setValue(initValue)
            }
            exercise_editormd.cm.on("change", (_cm, changeObj) => {
                console.log('....contentChanged')
                this.contentChanged = true;
            })
        });
        this.exercise_editormd = exercise_editormd;
        window.exercise_editormd = exercise_editormd;

    }

    formatSearch = (url) => {
        if (typeof url !== "undefined") {
            url = url.substr(1);  //从起始索引号提取字符串中指定数目的字符
            var arr = url.split("&"),  //把字符串分割为字符串数组
                obj = {},
                newarr = [];
            arr.forEach(function (v, i) { //数组遍历
                // console.log(v);
                // console.log(i);
                newarr = v.split("=");
                if (typeof obj[newarr[0]] === "undefined") {
                    obj[newarr[0]] = newarr[1];
                }
            });
            return obj;
        }
        ;
    }
    componentDidMount() {
        let id = this.props.match.params.shixunId;
        let checkpointId=this.props.match.params.checkpointId;

        let newchoice_url= "/shixuns/"+id+"/challenges/newquestion";
        let newpractice_url= "/shixuns/"+id+"/challenges/new";
        let newgo_back_url="/shixuns/"+id+"/challenges"
        if(checkpointId===undefined){
            //新建模式
            let url = "/shixuns/" + id + "/challenges/new.json"
            axios.get(url).then((response) => {
                this.setState({
                    choice_url: newchoice_url,
                    practice_url: newpractice_url,
                    go_back_url: newgo_back_url,
                    position: response.data.position,
                    task_pass_default: response.data.task_pass_default,
                    submit_url: response.data.submit_url,
                    checkpointId:checkpointId
                })
                this.exerciseMD(response.data.task_pass_default, "exercisememoMD");
            }).catch((error) => {
                console.log(error)
            });
        }else{
            //编辑模式
            let url="/shixuns/"+id+"/challenges/"+checkpointId+".json?tab=0";
            axios.get(url).then((response) => {

                let optionsum;
                if(response.data.difficulty===1){
                    optionsum=[100,200];
                }else if(response.data.difficulty===2){
                    optionsum=[300,400,500,600];
                }else if(response.data.difficulty===3){
                    optionsum=[700,800,900,1000]
                }
                let newprev_challenge=response.data.prev_challenge;
                let next_challenge=response.data.next_challenge;
                if (newprev_challenge != undefined) {
                    if(newprev_challenge.st===0){
                        newprev_challenge = "/shixuns/" + id + "/challenges/" + newprev_challenge.id + "/editcheckpoint";
                    }else{
                        newprev_challenge = "/shixuns/" + id + "/challenges/" + newprev_challenge.id  + "/editquestion";
                    }
                }
                if (next_challenge != undefined) {
                    if(next_challenge.st===0){
                        next_challenge = "/shixuns/" + id + "/challenges/" + next_challenge.id+ "/editcheckpoint";
                    }else{
                        next_challenge = "/shixuns/" + id + "/challenges/" + next_challenge.id+ "/editquestion";
                    }
                }
                this.setState({
                    power: response.data.power,
                    prev_challenge:newprev_challenge,
                    next_challenge:next_challenge,
                    choice_url: newchoice_url,
                    practice_url: newpractice_url,
                    go_back_url: newgo_back_url,
                    shixunCreatePractice:response.data.subject,
                    position:response.data.position,
                    shixunCreatePracticeGroup:response.data.difficulty,
                    optionsums:optionsum,
                    onshixunsmarkvalue:response.data.score,
                    shixunsskillvaluelist:response.data.tags,
                    checkpointId:checkpointId,
                    tab2url: "/shixuns/" + id + "/challenges/"+checkpointId+"/tab=2",
                    tab3url: "/shixuns/" + id + "/challenges/"+checkpointId+"/tab=3",
                })
                if(response.data.power===false){
                    this.props.showSnackbar("你没有权限修改");
                }
                this.exerciseMD(response.data.task_pass, "exercisememoMD");
            }).catch((error) => {
                console.log(error)
            });

        }

    }

    onshixunCreatePracticeChange = (e) => {
        let optionsum;
        let onshixunsmark;
        if(e.target.value===1){
            optionsum=[100,200];
            onshixunsmark=100;
        }else if(e.target.value===2){
            optionsum=[300,400,500,600];
            onshixunsmark=300;
        }else if(e.target.value===3){
            optionsum=[700,800,900,1000]
            onshixunsmark=700;
        }
        this.setState({
            shixunCreatePracticeGroup: e.target.value,
            optionsums:optionsum,
            onshixunsmarkvalue:onshixunsmark
        })
    }

    shixunCreatePractice = (e) => {
        this.setState({
            shixunCreatePractice: e.target.value
        })
    }

    CreatePracticesend = () => {
      this.setState({
        CreatePracticesendtype:true
      })

        if(this.props.status===2){
            this.props.showSnackbar("该实训已经发布不能新建")
            this.setState({
              CreatePracticesendtype:false
            })
            return
        }
        let {shixunCreatePractice, shixunCreatePracticeGroup, onshixunsmarkvalue, shixunsskillvaluelist} = this.state;
        if (shixunCreatePractice === undefined||shixunCreatePractice=="") {
            this.setState({
                shixunCreatePracticetype: true
            })
            this.props.showSnackbar("任务名称为空")
                $('html').animate({
                scrollTop: 10
            }, 1000);

          this.setState({
            CreatePracticesendtype:false
          })
            return
        }

        if (shixunsskillvaluelist.length === 0) {
            this.setState({
                shixunsskillvaluelisttype: true,
              CreatePracticesendtype:false
            })
            this.props.showSnackbar("技能标签为空")
            return
        }

        const exercise_editormdvalue = this.exercise_editormd.getValue();

        let id = this.props.match.params.shixunId;

        let url = "/shixuns/" + id + "/challenges.json";

        axios.post(url, {
            identifier:id,
            subject: shixunCreatePractice,
            task_pass: exercise_editormdvalue,
            difficulty: shixunCreatePracticeGroup,
            score: onshixunsmarkvalue,
            challenge_tag: shixunsskillvaluelist,
            st: 0
        }).then((response) => {
            this.props.showSnackbar(response.data.messages);
            if (response.data.status === 1) {
                this.setState({
                    setopen: true,
                    tab2url: "/shixuns/" + id + "/challenges/"+response.data.challenge_id+"/tab=2",
                    tab3url: "/shixuns/" + id + "/challenges/"+response.data.challenge_id+"/tab=3",
                })
                window.location.href = "/shixuns/" + id + "/challenges/"+response.data.challenge_id+"/tab=2"
            }

        }).catch((error) => {
            console.log(error)
        });



    }

    onshixunsmark = (value) => {
        this.setState({
            onshixunsmarkvalue: value
        })
    }

    shixunsskill = (e) => {
        this.setState({
            shixunsskillvalue: e.target.value
        })
    }

    clickshixunsskill = () => {

        let {shixunsskillvalue, shixunsskillvaluelist} = this.state;
        if (shixunsskillvalue === "") {
            return
        } else if (shixunsskillvalue === undefined) {
            return
        }

        if(shixunsskillvalue == "" || shixunsskillvalue == undefined || shixunsskillvalue == null || (shixunsskillvalue.length>0 && shixunsskillvalue.trim().length == 0)){
            message.error("输入为空，不能保存！");
            return
        }

         let list = shixunsskillvaluelist;
        list.push(shixunsskillvalue);
        this.setState({
            shixunsskillvaluelist: list,
            shixunsskillvalue: ""
        })
    }

    delshixunsskilllist = (key) => {
        let {shixunsskillvaluelist} = this.state;
        let newshixunsskillvaluelist = shixunsskillvaluelist;
        newshixunsskillvaluelist.splice(key, 1);
        this.setState({
            shixunsskillvaluelist: newshixunsskillvaluelist
        })
    }

    editPracticesend=()=>{

        this.setState({
          editPracticesendtype:true
        })

        let {shixunCreatePractice, shixunCreatePracticeGroup, onshixunsmarkvalue, shixunsskillvaluelist,checkpointId} = this.state;

        const exercise_editormdvalue = this.exercise_editormd.getValue();

        let id = this.props.match.params.shixunId;

        let url = "/shixuns/"+id+"/challenges/"+checkpointId+".json";

        if (shixunCreatePractice === undefined||shixunCreatePractice=="") {
            // this.setState({
            //     shixunCreatePracticetype: true
            // })
            this.props.showSnackbar("任务名称为空")
            $('html').animate({
                scrollTop: 10
            }, 1000);
            this.setState({
              editPracticesendtype:false
            })
            return
        }

        if (shixunsskillvaluelist.length === 0) {
            // this.setState({
            //     shixunsskillvaluelisttype: true
            // })
            this.props.showSnackbar("技能标签为空")
            this.setState({
              editPracticesendtype:false
            })
            return
        }
        axios.put(url, {
            tab:0,
            identifier:id,
            id:checkpointId,
            challenge:{
                subject: shixunCreatePractice,
                task_pass: exercise_editormdvalue,
                difficulty: shixunCreatePracticeGroup,
                score: onshixunsmarkvalue,
            },
            challenge_tag:shixunsskillvaluelist
        }).then((response) => {
            this.props.showSnackbar(response.data.messages);
            if (response.data.status === 1) {
                this.setState({
                    setopen: true,
                    tab2url: "/shixuns/" + id + "/challenges/"+checkpointId+"/tab=2",
                    tab3url: "/shixuns/" + id + "/challenges/"+checkpointId+"/tab=3",
                })
                window.location.href = "/shixuns/" + id + "/challenges/"+response.data.challenge_id+"/tab=2"
            }
        }).catch((error) => {
            console.log(error)
        });


    }

    onshixunsmarks=()=> {
        this.setState({
            marktype:true
        })
    }

    onshixunsmarkss=()=> {
        this.setState({
            marktype:false
        })
    }
    render() {

        let shixuntype = this.props.match.params.type;


        let {marktype,
            shixunCreatePracticetype, shixunsskillvaluelisttype,
            choice_url, practice_url, go_back_url, position, task_pass_default, submit_url, setopen,checkpointId,prev_challenge,next_challenge,power,
            shixunCreatePractice, shixunCreatePracticeGroup, onshixunsmarkvalue, shixunsskillvalue, shixunsskillvaluelist, tab2url, tab3url,optionsums,
            CreatePracticesendtype,editPracticesendtype
        } = this.state;

        let options;
        options = optionsums.map((d, k) => {
            return (
                <Option key={d} id={k}>{d}</Option>
            )
        })

        return (
            <React.Fragment>
                <div className="educontent mt30 mb30">
                    <div className="padding10-20 mb10 edu-back-white clearfix">
                        <span className="fl ring-blue mr10 mt7">
                            <img src={getImageUrl("images/educoder/icon/code.svg")} data-tip-down="实训任务" className="fl mt2 ml2"/>
                        </span>
                        <span className="font-16 task-hide fl TPMtaskName">第{position}关</span>

                        <Link to={go_back_url === undefined ? "" : go_back_url}
                              className="color-grey-6 fr font-16 ml30">返回</Link>

                        { prev_challenge===undefined?"":
                            <a href={prev_challenge} className="fr color-blue mr15 mt3">上一关</a>
                        }

                        { next_challenge===undefined?"":
                            <a href={next_challenge}className="fr color-blue mr15 mt3">下一关</a>
                        }


                        <a href={practice_url === undefined ? "" : practice_url}
                           className="fr color-blue mr15 mt4"
                           style={{display:this.props.identity>3||this.props.identity===undefined||this.props.status===2||this.props.status===1?"none":'block'}}
                           data-tip-down="新增代码编辑类型的任务">+&nbsp;实践类型</a>

                        <a href={choice_url === undefined ? "" : choice_url}
                           className="fr color-blue mr15 mt4"
                           style={{display:this.props.identity>3||this.props.identity===undefined||this.props.status===2||this.props.status===1?"none":'block'}}
                           data-tip-down="新增选择题类型的任务">+&nbsp;选择题类型</a>

                    </div>

                    <div className="challenge_nav clearfix edu-back-white">

                        <li className="active">
                            <a>本关任务</a>
                        </li>

                        <li className="">
                            {tab2url === "" ? <span>评测设置</span> : <Link to={tab2url}>评测设置</Link>}
                        </li>

                        <li className="">
                            {tab3url === "" ? <span>参考答案</span> : <Link to={tab3url}>参考答案</Link>}

                        </li>
                    </div>

                    <div className="edu-back-white mb10 clearfix">
                        <div className="padding40-20">
                            <p className="color-grey-6 font-16 mb30">任务名称</p>
                            <div className="df">
                                <span className="mr30 color-orange pt10">*</span>
                                <div className="flex1 mr20">
                                    <input type="text"
                                           // className="input-100-45 greyInput"
                                           className={shixunCreatePracticetype===true?"input-100-45 greyInpus wind100":"input-100-45 greyInput "}
                                           maxLength="50"
                                           name="challenge[subject]"
                                           value={shixunCreatePractice}
                                           onInput={this.shixunCreatePractice}
                                           placeholder="请输入任务名称（此信息将提前展示给学员）,例：计算学生的课程成绩绩点"/>
                                </div>
                                <div style={{width: '57px'}}>
                            <span
                                className={shixunCreatePracticetype === true ? "color-orange mt8 fl  block" : "color-orange mt8 fl none"}
                                id="new_shixun_name"><i
                                className="fa fa-exclamation-circle mr3"></i>必填项</span>
                                </div>
                            </div>
                        </div>
                    </div>


                    <div className="edu-back-white padding40-20 mb20">

                        <p className="color-grey-6 font-16 mb30">过关任务</p>

                        <div className="padding10-20 edu-back-greyf5 radius4" id="exercisememoMD">
                            <textarea style={{display: 'none'}}  onInput={this.Executiveorder} id="exercisememoMD_show" name="content"> </textarea>
                            <div className="CodeMirror cm-s-defualt">
                            </div>
                        </div>
                        <p id="e_tip_Memochallengesnew" className="edu-txt-right color-grey-cd font-12"></p>
                        <p id="e_tips_Memochallengesnew" className="edu-txt-right color-grey-cd font-12"></p>
                    </div>


                    <div className="edu-back-white padding40-20 mb20">
                        <p className="color-grey-6 font-16 mb30">难度系数</p>
                        <div className="clearfix mb40">

                            <RadioGroup value={shixunCreatePracticeGroup} className="fl mr40"
                                        disabled={this.props.status===2?true:false}
                                        onChange={this.props.status===2?"":this.onshixunCreatePracticeChange}>
                                <Radio value={1}>简单</Radio>
                                <Radio value={2}>中等</Radio>
                                <Radio value={3}>困难</Radio>
                            </RadioGroup>

                        </div>
                        <p className="color-grey-6 font-16 mb30">奖励经验值</p>
                        <div className="clearfix"   onMouseLeave={this.props.status===2?"":this.onshixunsmarkss}>
                            <span className="fl mr30 color-orange pt10">*</span>

                            <style>
                                {`            
                                   .ant-select-dropdown{
                                      top:1796px !important;
                                    }
                                `}
                            </style>
                            <Select style={{width: 120}} className="winput-240-40 fl"
                                    id="challenge_score"
                                    onChange={this.props.status===2?"":this.onshixunsmark}
                                    onMouseEnter={this.props.status===2?"":this.onshixunsmarks}
                                    disabled={this.props.status===2?true:false}
                                    open={marktype}
                                    value={onshixunsmarkvalue}
                                    getPopupContainer={triggerNode => triggerNode.parentNode}
                            >
                                {options}
                            </Select>

                            <p className="fl color-grey-9 font-12 ml20">
                                如果学员答题错误，则不能得到相应的经验值<br/>
                                如果学员成功得到经验值，那么将同时获得等值的金币奖励，如：+10经验值、+10金币
                            </p>

                            <span className="color-orange mt7 fl ml20 none" id="ex_value_notice"><i
                                className="fa fa-exclamation-circle mr3"></i>必填项</span>
                        </div>
                    </div>


                    <div className="edu-back-white padding40-20 mb20">
                        <p className="color-grey-6 font-16 mb30">技能标签</p>
                        <div className="clearfix df">
                            <span className="mr30 color-orange pt10">*</span>
                            <div className="flex1">
                                <Input type="text"
                                       className="winput-240-40 fl mr20 winput-240-40s"
                                       id="input_task_tag"
                                       placeholder="添加标签"
                                       onInput={this.shixunsskill}
                                       value={shixunsskillvalue}
                                       onPressEnter={this.clickshixunsskill}
                                       onBlur={this.clickshixunsskill}
                                />
                                {/*<a className="white-btn orange-btn fl mt1 use_scope-btn ml20 mt5 mr20"*/}
                                   {/*onClick={this.clickshixunsskill}>+ 添加</a>*/}
                                <div className="ml15 color-grey-9 mt5">学员答题正确将获得技能，否则不能获得技能</div>
                                <div className="mt20 clearfix" id="task_tag_content">

                                    {
                                        shixunsskillvaluelist.length === 0 ? "" : shixunsskillvaluelist.map((itme, key) => {
                                            return (
                                                <li className="task_tag_span" key={key}><span>{itme}</span>
                                                    <a onClick={() => this.delshixunsskilllist(key)}>×</a>
                                                </li>
                                            )
                                        })
                                    }


                                </div>
                            </div>
                            <span
                                className={shixunsskillvaluelisttype === true ? "color-orange mt7 fl ml20 block" : " color-orange mt7 fl ml20 none"}
                                id="stage_name_notice">
                        <i className="fa fa-exclamation-circle mr3"></i>必填项</span>
                        </div>
                    </div>

                    <div className="clearfix mt30"
                         style={{display:this.props.identity>3||this.props.identity===undefined?"none":'block'}}
                    >
                       {checkpointId===undefined?<a className="defalutSubmitbtn fl mr20" onClick={CreatePracticesendtype===true?"":this.CreatePracticesend}>提交</a>:
                       <a className="defalutSubmitbtn fl mr20" onClick={editPracticesendtype===true?"":this.editPracticesend}>提交</a>}
                       <a href={go_back_url === undefined ? "" : go_back_url} className="defalutCancelbtn fl">取消</a>
                    </div>
                </div>
            </React.Fragment>
        )
    }
}


