import React, { Component } from 'react';

import { SnackbarHOC, getImageUrl } from 'educoder';
import AccountImg from './AccountImg'
class AccountNav extends Component {
  toBasic = () => {
    this.props.history.push(`/account/basic`)
  }
  toCertification = () => {
    this.props.history.push(`/account/certification`)
  }
  toSecure = () => {
    this.props.history.push(`/account/secure`)
  }
    render() {
      const path = window.location.pathname
      const isBasic = path.indexOf('basic') != -1 || path == "/account"
      const isCertification = path.indexOf('certification') != -1
      const isSecure = path.indexOf('secure') != -1
      return (
          <div className="accountNav">
            <style>{`
              .accountNav {
                width: 290px;
                box-shadow: 0px 4px 9px 0px rgba(11,62,120,0.21);
                border-radius: 2px;
                padding-top: 8px;
                padding-bottom: 32px;

                margin: 20px;
              }
              .accountInfo { 
                text-align: center;
                display: flex;
                flex-direction: column;
                align-items: center;
              }
              .accountInfo .name {
                color: #05101A;
                font-size: 24px;
                height: 36px;
              }
              .accountInfo .role {
                color: #666666;
                font-size: 14px;
              }
              .accountManagement {

              }
                .accountManagement .title {
                  color: #05101A;
                  font-size: 18px;
                  font-weight: bold;
                  padding: 10px 28px;
                  margin-top: 6px;
                }
                .accountManagement .navItem {
                  font-size: 16px;
                  padding: 6px 0px;
                  padding-left: 30px;
                  border-left: 2px solid #fff;
                  cursor: pointer;
                }
                  .accountManagement .navItem i{
                    margin-top: -4px;
                    display: inline-block;
                    margin-right: 3px;
                  }
                  .accountManagement .navItem i.status{
                    margin-top: 1px;
                    margin-right: 24px;
                  }
                .accountManagement .navItem.active { 
                  border-left: 2px solid #4CACFF;
                  background: #E6F3FF;
                }
            `}</style>
            <div className="accountInfo">
              <AccountImg></AccountImg>
              <span className="name">莎莎</span>
              <span className="role">管理员</span>
            </div>

            <div className="accountManagement">
              <div className="title">账号管理</div>
              <ul>
                <li className={`navItem ${isBasic ? 'active' : ''}`} onClick={this.toBasic}>
                  <i className="iconfont icon-dianzan color-grey-9 font-16"></i>
                  基本信息
                  <i className="status fr iconfont icon-dianzan color-grey-9 font-16"></i>                  
                </li>
                <li className={`navItem ${isCertification ? 'active' : ''}`} onClick={this.toCertification}>
                  <i className="iconfont icon-dianzan color-grey-9 font-16"></i>认证信息
                </li>
                <li className={`navItem ${isSecure ? 'active' : ''}`} onClick={this.toSecure}>
                  <i className="iconfont icon-dianzan color-grey-9 font-16"></i>安全设置
                </li>
              </ul>
            </div>
          </div>
      );
    }
}

export default  AccountNav ;
