import React, { Component } from "react";
import { Modal, Button, Input, Form, } from "antd";
import axios from 'axios'
import ModalWrapper from "../../courses/common/ModalWrapper"
import { City } from 'educoder'
import '../account/common.css'

const { TextArea } = Input;
const Search = Input.Search
class ApplyForAddOrgModal extends Component{
  constructor(props){
    super(props);
    this.state={
      
    }
  }

  componentDidMount() {
    
  }
  setVisible = (visible) => {
    this.refs.modalWrapper.setVisible(visible)
  }

  onSendOk = () => {
   

  }

  onOk = () => {
    const { course_lists, checkBoxValues } = this.state
    this.onSendOk()
  }

  render(){
    const { course_lists, checkBoxValues, searchValue, loading, hasMore } = this.state
    const { moduleName } = this.props
    const { getFieldDecorator } = this.props.form;
    return(
      <ModalWrapper
        ref="modalWrapper"
        title={`申请添加单位名称`}
        {...this.props }
        onOk={this.onOk}
        okText="保存"
        className="modalForm"
      >
        <style>{`
          .modalForm .ant-form-item-label {
            width: 100px;
            padding-right: 10px;
          }
          .modalForm .ant-form-item-label label {
            color: #979797
          }
          .formItemInline .ant-form-item-control-wrapper {
            width: 390px;
          }
        `}</style>
        <Form>
          <Form.Item
            label="单位全称："
            className="mt15 formItemInline hideRequireTag"
          >
            {getFieldDecorator('orgName', {
              rules: [{
                // initialValue: this.state.cityDefaultValue,
                required: true, 
                message: '请输入学校或工作单位',
              }],
            })(
              <Input placeholder="学校或工作单位" className="validateInput"></Input>
            )}
            <div>
              <div style={{ height: '22px'}}>
                <span>示例：</span>
                <i className="iconfont icon-dianzan color-grey-9 font-16"></i>
                <span> 国防科学技术大学</span>
              </div>
              <div style={{ height: '22px'}}>
                <span>　　　</span>
                <i className="iconfont icon-dianzan color-grey-9 font-16"></i>
                <span> 国防科学技术大学四方坪校区</span>
              </div>
            </div>
          </Form.Item>
          
          <Form.Item
            label="地区："
            className="mt15 formItemInline hideRequireTag"
          >
            {getFieldDecorator('re', {
              rules: [{
                // initialValue: this.state.cityDefaultValue,
                required: true, 
                message: '请选择地区',
              }],
            })(
              <City ></City>
            )}
          </Form.Item>

          <Form.Item
            label="详细地址："
            className="mt15 formItemInline hideRequireTag"
          >
            {getFieldDecorator('addr', {
              rules: [{
                // initialValue: this.state.cityDefaultValue,
                required: true, 
                message: '请填写完整的地址信息',
              }],
            })(
              <Input placeholder="请填写完整的地址信息" className="validateInput"></Input>
            )}
          </Form.Item>

          <Form.Item
            label="说明："
            className="mt15 formItemInline hideRequireTag"
          >
            {getFieldDecorator('desc', {
            })(
              <TextArea placeholder="再次说明特别情况（选填）" className="validateInput"></TextArea>
            )}
          </Form.Item>

        </Form>
        

      </ModalWrapper>
    )
  }
}
const WrappedApplyForAddOrgModal = Form.create({ name: 'ApplyForAddOrgModal' })(ApplyForAddOrgModal);

export default WrappedApplyForAddOrgModal;


