import React, { Component } from 'react';
import { SnackbarHOC } from 'educoder';
import {Tooltip,Menu} from 'antd';
import InfosCourse from './InfosCourse';
import InfosShixun from './InfosShixun';
import InfosProject from './InfosProject';
import InfosPath from './InfosPath';
import InfosBank from './InfosBank';
import axios from 'axios';
import {getImageUrl} from 'educoder';
import { TPMIndexHOC } from '../../tpm/TPMIndexHOC';
import { CNotificationHOC } from '../../courses/common/CNotificationHOC'
import "./usersInfo.css"
import "../../courses/css/members.css"
import "../../courses/css/Courses.css"
import update from 'immutability-helper'


const $ = window.$;
class Infos extends Component{
  constructor(props){
    super(props);
    this.state={
      data:undefined,
      is_current:true,
      is_edit:false,
      sign:undefined,
      type:0,
      login:undefined
    }
  }
  componentDidMount =()=>{
    this.getInfo(this.props.match.params.username);
  }
  //判断是否看的是当前用户的个人主页
  componentDidUpdate =(prevProps)=> {
    if(this.props.current_user && prevProps.current_user != this.props.current_user){
      console.log(this.props);
      if(this.props.current_user.login != this.props.match.params.username){
        this.setState({
          is_current:false,
          login:this.props.current_user.login
        })
      }
    }
  }
  //获取个人主页信息
  getInfo = (user_login) =>{
    let url =`/users/${user_login}/homepage_info.json`;
    axios.get(url).then((result)=>{
      if(result){
        this.setState({
          data:result.data,
          followed:result.data.followed,
          sign:result.data.brief_introduction,
          id:result.data.id
        })
      }
    }).catch((error)=>{
      console.log(error);
    })
  }

  // 编辑签名
  editmysign=()=>{
    this.setState({
      is_edit:true
    },()=>{
      $("#mysign").focus();
    })
  }
  // 输入签名
  inputSign=(e)=>{
    this.setState({
      sign:e.target.value
    })
  }
  //取消编辑签名
  savemysign=()=>{
    let { sign } =this.state;
    let url=`/users/brief_introduction.json`;
    axios.post((url),{
      content:sign
    }).then((result)=>{
      if(result){
        this.setState({
          is_edit:false
        })
      }
    }).catch((error)=>{
      console.log(error)
    })
    
  }
  changeType=(e)=>{
    this.setState({
      type:e.key
    })
  }
  turnTo=(url)=>{
    this.props.history.push(url);
  }

  //签到
  signFor=()=>{
    let url=`/users/attendance.json`
    axios.post(url).then((result)=>{
      if(result){
        this.setState(
          (prevState) => ({ 
            data : update(prevState.data, {attendance_signed: {$set: true} })
          })
        )
      }
    }).catch((error)=>{
      console.log(error);
    })
  }

  // 关注
  followPerson=()=>{
    let{followed,id}=this.state;
    let url=`/users/${id}/watch.json`;
    // 取消关注
    if(followed){
      axios.delete(url).then((result)=>{
        if(result){
          this.setState({
            followed:false
          })
        }
      }).catch((error)=>{
        console.log(error)
      })
    }else{
      // 关注
      axios.post(url).then((result)=>{
        if(result){
          this.setState({
            followed:true
          })
        }
      }).catch((error)=>{
        console.log(error);
      })
    }
  }

  render(){
    let { 
      data ,
      is_current,
      is_edit,
      sign,
      type,
      followed,
      id,
      login
     }=this.state;
     let {username}= this.props.match.params;
     let {isAdmin}=this.props.isAdmin();
    return(
      <div className="newMain">
        <div className="user-main-half">
          <div className="user-headImg"></div>
          <div className="user-headCon">
            <div className="pr" style={{"min-height": "465px"}}>
              <div className="educontent pt80 clearfix edu-txt-center">
                <div className="inline">
                  <div className="fl headtab">
                    <span>{is_current ? "我":"TA"}的经验值</span>
                    <a href={`/users/${username}/user_experience`}>{data && data.experience}</a>
                  </div>
                  <em className="v-h-line fl"></em>
                  <div className="fl headtab">
                    <span>{is_current ? "我":"TA"}的金币</span>
                    <a href={`/users/${username}/user_grade`} id="user_code">{data && data.grade}</a>
                  </div>
                  <div className="headphoto mt14">
                    <img alt="头像" id="user_avatar_show" nhname="avatar_image" src={data && `${getImageUrl('images/'+data.avatar_url)}`}/>
                  </div>
                  <div className="fl headtab">
                    <span>{is_current ? "我":"TA"}的粉丝</span>
                    <a href={`/users/${username}/user_fanslist`} id="user_h_fan_count">{data && data.fan_count}</a>
                  </div>
                  <em className="v-h-line fl"></em>
                  <div className="fl headtab">
                    <span>{is_current ? "我":"TA"}的关注</span>
                    <a href={`/users/${username}/user_watchlist`}>{data && data.follow_count}</a>
                  </div>
                  <span className="clearfix"></span>
                  <span className="myName">{data && data.name}</span>
                </div>
              </div>
              <div className="educontent mt10 clearfix edu-txt-center">
                <div className="inline">
                  <span className="mypost fl mr10">{data && data.identity}</span>
                  <a href={is_current ? "/account/authentication" :"javascript:void(0)"} target="_blank" className={is_current ? "ringauto fl" :"ringauto fl cdefault"}>
                    <Tooltip placement='bottom' title={ data && data.authentication ?"已实名认证":"未实名认证"}>
                      <i className={ data && data.authentication ? "iconfont icon-shenfenrenzheng font-13 color-blue":"iconfont icon-shenfenrenzheng font-13 color-grey-9"}></i>
                    </Tooltip>
                  </a>
                  <a href={is_current ? "/account/professional_certification" :"javascript:void(0)"} target="_blank" className={is_current ? "ringauto fl" :"ringauto fl cdefault"}>
                    <Tooltip placement='bottom' title={ data && data.professional_certification ?"已职业认证":"未职业认证"}>
                      <i className={ data && data.professional_certification ? "iconfont icon-zhiyerenzheng font-13 color-blue":"iconfont icon-zhiyerenzheng font-13 color-grey-9"}></i>
                    </Tooltip>
                  </a>
                  <a href={is_current ? "/account/change_or_bind?type=phone" :"javascript:void(0)"} target="_blank" className={is_current ? "ringauto fl" :"ringauto fl cdefault"}>
                    <Tooltip placement='bottom' title={ data && data.phone_binded ?"已手机认证":"未手机认证"}>
                      <i className={ data && data.phone_binded ? "iconfont icon-shoujirenzheng font-13 color-blue":"iconfont icon-shoujirenzheng font-13 color-grey-9"}></i>
                    </Tooltip>
                  </a>
                  <a href={is_current ? "/my/account" :"javascript:void(0)"} target="_blank" className={is_current ? "ringauto fl" :"ringauto fl cdefault"}>
                    <Tooltip placement='bottom' title={ data && data.email_binded ?"已邮箱认证":"未邮箱认证"}>
                      <i className={ data && data.email_binded ? "iconfont icon-youxiangrenzheng font-13 color-blue":"iconfont icon-youxiangrenzheng font-13 color-grey-9"}></i>
                    </Tooltip>
                  </a>
                  {/* <!--学院管理员身份--> */}
                  {
                    data && data.college_identifier &&
                    <a href={`/colleges/${data.college_identifier}/statistics`} target="_blank" className={is_current ? "ringauto fl" :"ringauto fl cdefault"}>
                      <Tooltip placement='bottom' title="学院管理员">
                        <i className="iconfont icon-chengyuanguanli font-12 color-blue" data-tip-down="学院管理员"></i>
                      </Tooltip>
                    </a>
                  }
                </div>
              </div>
              <div className="mt15 educontent clearfix edu-txt-center">
                <p className="mb20" style={{"height": "28px"}}>
                  {
                    is_edit && is_current ? 
                    <input type="text" id="mysign" class="mysign-input" placeholder="请输入您的个性签名" style={{height:"20px"}} value={sign} onInput={this.inputSign} onBlur={this.savemysign}/>
                    :
                    is_current ? 
                    <a className="mysign-span" onClick={this.editmysign} style={{"display": "block"}}>{sign || "这家伙很懒，什么都没留下~"}</a>
                    :
                    <span className="mysign-span" style={{"display": "block","cursor":"default"}}>{sign || "这家伙很懒，什么都没留下~"}</span>
                  }
                </p>
                {
                  is_current ? 
                  <div className="inline">
                    {
                      data && data.can_apply_trial == false ?
                        data.attendance_signed ? 
                        <React.Fragment>
                          <span className="user_default_btn user_grey_btn mb5 fl">已签到</span>
                          <span id="attendance_notice" className="none font-12 color-grey-6" style={{"display":"block"}}>明日签到&nbsp;<font className="color-orange">+{data && data.tomorrow_attendance_gold}</font>&nbsp;金币</span>
                        </React.Fragment>
                        :
                        <a herf="javascript:void(0);" onClick={this.signFor} id="attendance" className="user_default_btn user_orange_btn fl mb15">签到</a>
                      :
                      <a herf="javascript:void(0);" onClick="user_apply_trail();" id="authentication_apply" className="user_default_btn user_private_btn fl ml15">试用申请</a>
                    }
                  </div> 
                  :
                  <div className="inline">
                    <a href="javascript:void(0);" onClick={this.followPerson} className="user_default_btn user_watch_btn user_private_btn fl mr20">{followed ? "取消关注":"关注"}</a>
                    <a href={`/users/${login}/message_detail?user_id=${id}`} className="user_default_btn user_private_btn fl">私信</a>
                  </div>
                }
              </div>
              <div className="edu-txt-center navInfo">
                <div className="inline">
                  <Menu mode="horizontal" defaultSelectedKeys="0" onClick={this.changeType}>
                    <Menu.Item key="0">课堂</Menu.Item>
                    <Menu.Item key="1">实训</Menu.Item>
                    <Menu.Item key="2">实训课程</Menu.Item>
                    <Menu.Item key="3">项目</Menu.Item>
                    { isAdmin && <Menu.Item key="4">题库</Menu.Item> }
                  </Menu>
                </div>
              </div>
            </div>
          </div>
        </div>
        {
          parseInt(type) == 0 && <InfosCourse {...this.props} {...this.state} login={username} is_current={is_current}></InfosCourse>
        }
        {
          parseInt(type) == 1 && <InfosShixun {...this.props} {...this.state} login={username} is_current={is_current}></InfosShixun>
        }
        {
          parseInt(type) == 2 && <InfosPath {...this.props} {...this.state} login={username} is_current={is_current}></InfosPath>
        }
        {
          parseInt(type) == 3 && <InfosProject {...this.props} {...this.state} login={username} is_current={is_current}></InfosProject>
        }
        {
          parseInt(type) == 4 && <InfosBank {...this.props} {...this.state} login={username} is_current={is_current}></InfosBank>
        }
      </div>
    )
  }
}
export default CNotificationHOC() ( SnackbarHOC() ( TPMIndexHOC(Infos) ));